//--------------------------------------------------------
//   AECntRDR.C -- Displays " hh:mm:ss:ff " in client area for 
//			time code reading boards with their base addresses.
//		    Also prints the AEC_NTTC.DLL file Revision Number.  
//
// Revised to support PCI-TC, USB-TC and PCIe-TC devices. (9/08)
//--------------------------------------------------------
    //NOTE: WHERE THERE IS A 'WO' IN THE COMMENTS BELOW, IT STANDS FOR
		// 'WINDOWS OVERHEAD'. THE 'WO' CODE HELPS TO DRAW THE
		// WINDOW, UPDATE THE WINDOW, ETC.

#include <windows.h>
#include <winioctl.h>		// in mstools\include dir
#include <stdio.h>
#include <stdlib.h>

#include "..\AEC_NTTC.h"		//PROTOTYPES OF THE AECxxx-TC AEC_NTTC.DLL FUNCTIONS
								//for file in shared parent directory (shared file)




#define		true	1
#define		false	0
#define		NONE	0x0000
#define		IOR		0x0095
#define		MMR		0x0090
#define		SMART	0x0050
#define		VLTC	0x0050
#define		LTC		0x0098
#define		VITC	0x0093
#define		PCI 	0x0100	//includes PCI-TC, USB-TC and PCIe-TC

typedef struct _AECBrdFnd
	{
		WORD	BrdAddr;		//ie: 0x02A0, 0xCC00, 0x1000 (PCI)
		int		BrdCkType;		// 1=IOR, 2=MMR, 3=smart, 4=PCI/USB/PCIe
		WORD	BrdModel;		// LTC/, VITC/ VLTC/
		BOOL	BrdReads;		//TRUE for IOR/MMR/RDR/RG1
		BOOL	BrdGens;		//TRUE for GEN/RG1
		BOOL	BrdHasVid;		//TRUE for GEN/VITC/VLTC
		PVOID	PhysAddr;		//available IF memory mapped ISA device
	} AECBrdFnd, *PAECBrdFnd;


//VARIABLE DEFINITIONS
AECBrdFnd	AecBoard[6];	// hold data for time code boards
							// that are found (if it is installed/registered).
int		boardNum, BoardsFound;			// number of boards found in registry
int		aecint;
int		i1, i2, i3;
char	hhmmssff[12];	    //data string to hold formated unpacked dataC
char	hhmmssffx[30];
char	charStr[20], rev[2];//character string to hold data sent to screen


volatile BOOL   exiting;
volatile int	iOtherCnt, iVidCnt, iGenCnt, iReadCnt;
volatile BOOL	bRnew, bGnew, bVnew;
DWORD	lRTdat, lGTdat, lRTdatOld;
//DWORD	lRUdat, lGUdat;
//ULONG	lRTdat, lRUdat;
//ULONG	lGTdat, lGUdat;

WORD	B_Addr;
LPSTR	lpPassToAECDLLrev, lpStr1;	// typedef  char FAR*	LPSTR  
BOOL	OSD_ON;

//Function Prototypes
BOOL	LookForEvent(int);
int		LtoStrTm(ULONG, char*);
int		FindAllBoards(void);
//void	RecordSmart(int, WORD);
void	RecordPci(int, WORD);
long	WINAPI WndProc (HWND, UINT, UINT, LONG) ;
	    //window proceedure (WndProc) PROTOTYPE

HDC			hdc;				// WO
PAINTSTRUCT	ps;					// WO
RECT		rect;				// WO
MSG			msg;	//Global message structure that several
				    // functions use as a parameter

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//int WINAPI WinMain (HANDLE hInstance, HANDLE hPrevInstance,
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
    {

	BOOL bRet;
    static char szAppName[] = "AEC TC TEST/DEMO (Win32)" ;
    HWND	 hwnd ;
    WNDCLASS	 wndclass ;
    //lpPassToAECDLLrev = (LPSTR) &rev;

	exiting = false;
	
	boardNum = AEC_PCTC_GET_NUMBER_OF_DEVICES ();	//# use when dll

	OSD_ON = false;
//Code in this section is special just to enable OSD operations of a PCI w/OSD
//in a prgramatic (automatic) way.
// For "Mike Wheeler"

//	OSD_ON = true;
	BoardsFound = FindAllBoards();
	if (OSD_ON)
	{
		exit(0);	//all done
	}
// Change name of compiled program to "AecOSD_AutoOn.exe"


    if (!hPrevInstance) //WO used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		// WO
	  wndclass.lpfnWndProc	 = WndProc ;					// WO
	  wndclass.cbClsExtra	 = 0 ;							// WO
	  wndclass.cbWndExtra	 = 0 ;							// WO
	  wndclass.hInstance	 = hInstance ;					// WO
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	// WO
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	// WO
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	// WO
	  wndclass.lpszMenuName  = NULL ;						// WO
	  wndclass.lpszClassName = szAppName ;					// WO

	  RegisterClass (&wndclass) ;							// WO
	  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, //ext.window style(always on top)
		    szAppName,				// address of registered class name
		    "AEC TC READER/GENERATOR Demo (Alt+F4 to exit)",						// window text
		    //WS_THICKFRAME | WS_SYSMENU,					// window style
			WS_CAPTION,
		    100,								// initial x position
		    80,								// initial y position
		    0x180,							// window width
		    0x58,							// window height
            NULL,                   // parent window handle
            NULL,                   // window menu handle
            hInstance,              // program instance handle
		    NULL) ;							// creation parameters

//--------------------------------
		// Make this program have high Priority or the
		// software interrupts may not be processed quickly enough
//		SetPriorityClass ( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );
//--------------------------------
//	BoardsFound = FindAllBoards();		//called above earlier on
//--------------------------------

    ShowWindow (hwnd, nCmdShow) ;	// WO part of the window creation
    UpdateWindow (hwnd) ;			// WO part of the window creation

//-->
SetTimer(hwnd,             // handle to main window 
    1,            // timer identifier 
    10,                     // ?ms interval 
    (TIMERPROC) NULL);     // no timer callback 
//<--


	InvalidateRect ( hwnd, NULL, 0 );	//draw client area first time...
/*++ This part of the code was taken out (changed to below) when WM_TIMER was added to handle....
	GetMessage (&msg, NULL, 0, 0);

    do					// loop until "close"
	{
		//-->
		TranslateMessage (&msg) ;				
		DispatchMessage (&msg) ;				
		//InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
//		do
//		{
//			if (LookForEvent(0))	//If a software interrupt has occured
//			{
//				InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
//				Sleep(5);
//			}			
//			Sleep(5);	//release thread for a little bit of time each loop
		}
		while (!(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))); //while no msg - NONZERO if message available
		//Nonzero -> success, Zero -> failure
	    // look for any messages (allows Windows access to Main loop)

		TranslateMessage (&msg) ;				
		DispatchMessage (&msg) ;				
		InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window

	}
--*/
	while( (bRet = GetMessage( &msg, NULL, 0, 0 )) != 0)
	{ 
		if (bRet == -1)
		{
			// handle the error and possibly exit
			Sleep(100);
		}
		else
		{
			TranslateMessage(&msg); 
			DispatchMessage(&msg); 
		}
	}


//--> new
//   // Acquire and dispatch messages until a WM_QUIT message is received.
//    while( GetMessage(&msg, NULL, 0, 0))
//    {
//        if (!TranslateAccelerator (msg.hwnd, hAccelTable, &msg))
//        {
//            TranslateMessage(&msg);  // Translates virtual key codes
//            DispatchMessage(&msg);   // Dispatches message to window
//        }
//    }
//<-- new

    return msg.wParam ; 						// WO // Returns the value from PostQuitMessage
    }



// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		    //WINDOW PROC
long WINAPI WndProc (HWND hwnd, UINT message, UINT wParam, LONG lParam)
{
	char	Dllrev[10];//character string to hold data sent to screen
    lpPassToAECDLLrev = (LPSTR) &Dllrev;


	switch (message)								// WO
    {
	  case WM_PAINT:
		  hdc = BeginPaint (hwnd, &ps) ;			// WO
		  GetClientRect (hwnd, &rect) ;				// WO

		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		  //print to the screen the data being read by the time code 
		  //	board(s) that has been found (if any). (up to 3 board's 
		  //	reader data will automaticly be displayed)
		if ( BoardsFound != 0 )
		{
			if (bRnew)
			{
				bRnew = FALSE;		//reset this flag
				aecint = LtoStrTm(lRTdat, charStr);
					DrawText (hdc,			//PRINT IN THE WINDOW
						charStr,
						aecint,
						&rect,
						DT_SINGLELINE | DT_VCENTER);				
			}

		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			if (bGnew)			//print the GENERATOR data
			{		
				bGnew = FALSE;		//reset this flag
				//lGTdat, lGUdat
				aecint = LtoStrTm(lGTdat, charStr);
				DrawText (hdc,			//PRINT IN THE WINDOW
					charStr,
					aecint,
					&rect,
					DT_SINGLELINE | DT_VCENTER | DT_RIGHT );
			}

		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			if (bVnew)	//print the video field interrupt timing...
			{
				bVnew = FALSE;		//reset flag value
				DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
					hhmmssff,
					wsprintf (hhmmssff,"fld= %d",
					iVidCnt),
					&rect,
					//DT_SINGLELINE | DT_RIGHT | DT_BOTTOM);
					DT_SINGLELINE | DT_VCENTER | DT_CENTER);
			}

		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			else
			{

				//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				// print the dll rev info and the number of boards that the
				// find function has returned and the number of boards that 
				// the dll has registered.
				aecint = AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev);
				//uses the AECDLL.DLL.  It passes the DLL revision 
				DrawText (hdc,			//PRINT THE DLL REV TO WINDOW
					   //rev,
					   //aecint,
					   hhmmssff,
					   wsprintf (hhmmssff,"DLL Rev. %c%c",
		 			   Dllrev[0], Dllrev[1]),
					   &rect,
					   DT_SINGLELINE | DT_CENTER | DT_BOTTOM);
					//print the 'boardNum'
				DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
					hhmmssff,
					wsprintf (hhmmssff,"%X (in Registry)",
					boardNum),
					&rect,
					DT_SINGLELINE | DT_BOTTOM );
					//print the 'BoardsFound'
				DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
					hhmmssff,
					wsprintf (hhmmssff,"%X (Boards Found)",
					BoardsFound),
					&rect,
					DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);

				B_Addr = AecBoard[0].BrdAddr;
				DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
					hhmmssff,
					wsprintf (hhmmssff,"%X",
					B_Addr),
					&rect,
					DT_SINGLELINE | DT_CENTER  );


				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"TC READ"),
					&rect,
					DT_SINGLELINE);
				DrawText (hdc,		
					hhmmssff,
					wsprintf (hhmmssff,"TC GEN"),
					&rect,
					DT_SINGLELINE | DT_RIGHT );
				if (!AecBoard[0].BrdGens)
					DrawText (hdc,		
						hhmmssff,
						wsprintf (hhmmssff,"------"),
						&rect,
						DT_SINGLELINE | DT_VCENTER | DT_RIGHT );

			}
		}
		else
		{
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// print the dll rev info and the number of boards that the
			// find function has returned and the number of boards that 
			// the dll has registered.
			aecint = AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev);
			//uses the AECDLL.DLL.  It passes the DLL revision 
			DrawText (hdc,			//PRINT THE DLL REV TO WINDOW
				   hhmmssff,
				   wsprintf (hhmmssff,"DLL Rev. %c%c",
		 		   rev[0], rev[1]),
				   &rect,
				   DT_SINGLELINE | DT_CENTER | DT_BOTTOM);	
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%X",
				boardNum),
				&rect,
				DT_SINGLELINE | DT_BOTTOM );	//print the 'boardNum'				
			DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
				hhmmssff,
				wsprintf (hhmmssff,"%X",
				BoardsFound),
				&rect,
				DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);	//print the 'BoardsFound'
		}
		
		EndPaint (hwnd, &ps) ;					//WO
	       return 0 ;								//WO


	  case WM_TIMER: 
		  //MessageBeep(-1);
		  if (!exiting)
		  {
			  if (LookForEvent(0))	//If a software interrupt has occured
				{
					InvalidateRect ( hwnd, NULL, 0 );		// forces redraw of window
					//Sleep(5);
					if (LookForEvent(0))	//2nd pass for "look at other stuff"
						LookForEvent(0);	//3rd
				}
		  }
		  else 
			  MessageBeep(-1);
		  return 0;
	

	  case WM_DESTROY:								// WO
		   Sleep(500);

	       PostQuitMessage (0) ;					// WO
	       return 0 ;								// WO

	  case WM_CLOSE:
		  KillTimer(hwnd, 1); 
		  
		  exiting = true;
		  Sleep(500);
		  DestroyWindow(hwnd);
		  return 0;

		//default:...None
     
	}

     return DefWindowProc (hwnd, message, wParam, lParam) ;	// WO

}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Call the 'Check_board' function for each of the possible addresses
//	that a time code board could be at and then store the board Type and
//	determine if the board has reading ability (some Smart boards are
//	generate only).  
// Returns the number of boards that where found.
//
//	PC-LTC/IOR BOARDS HAVE STANDARD ADDRESS JUMPER SETTINGS OF...
//	(port mapped)	200h, 220h, 280h, 2A0h, 300, 320h, 380h, & 3A0h
//	PC-LTC/MMR ... C0(00)h, C4(00)h, C8(00)h, CC(00)h, D0(00)h, D4(00)h
//	(memory mapped)		D8(00)h, & DC(00)h.
//	PC-LTC/(RDR, GEN, RG1) & ALL PC-VITC/XXX & ALL PC-VLTC/XXX HAVE
//		ADDRESS... CC00h, CD00h, CE00h, CF00h, DC00h, DD00h, DE00h, & DF00h
// The 'actual' address that the memory mapped boards are 'physically' 
//	mapped to is four bits higher than the jumper's lable. 
//	(ie: CC00 -> CC000h address
// PCI-LTC/RDR, all other PCI- TC models, are accessed by calling the
//  DLL with address parameter values of 0x1000 and up (increased by 0x0100)
//  to 0x2100 (total 18 different addresses). These address are arbitrary
//  (defined in the DLL). The first PCI board "found" by scanning of
//  the PCI bus by the driver/enumerator will be assigned the 0x1000
//  address "code" by the DLL. Each board after will be assigned the
//  next address up to MAX.
int	  FindAllBoards(void)
{
	WORD	BrdAddr, Offset;
	DWORD	wId;
	int		CkType, FoundCnt;
	BOOL	bRet;

	FoundCnt = 0x00;



	//see if there are any PCI boards
	BrdAddr = 0x1000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		/*++
		if (OSD_ON)
		{
			//Write four bytes to offset 24 (OSD control regs) and exit
			Offset = 0x24;				// OSD register offset address
			wId = 0x00240100;			// OSD settings
			bRet = AEC_PCTC_WRITE_4BYTES (&wId, &Offset, &BrdAddr);
			return FoundCnt;
		}	--*/

		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		RecordPci(FoundCnt, BrdAddr);
		FoundCnt++;
	}

	BrdAddr = 0x1100;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		RecordPci(FoundCnt, BrdAddr);
		FoundCnt++;
	}
	BrdAddr = 0x1200;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		RecordPci(FoundCnt, BrdAddr);
		FoundCnt++;
	}

/*++
	.
	.
	.
	BrdAddr = 0x1300;
	BrdAddr = 0x1400;
	BrdAddr = 0x1500;
	BrdAddr = 0x1600;
	BrdAddr = 0x1700;	//These address are OK, but will NOT
	BrdAddr = 0x1800;	//		ever be used until the above
	BrdAddr = 0x1900;	//		are used first, so these will
	BrdAddr = 0x1A00;	//		not get used by this program.
	BrdAddr = 0x1B00;	//		These can be used if you have
	BrdAddr = 0x1C00;	//		system that will use more than
	BrdAddr = 0x1D00;	//		three PCI time code devices
	BrdAddr = 0x1E00;
	BrdAddr = 0x1F00;
	BrdAddr = 0x2000;
	BrdAddr = 0x2100;
--*/

		/*++  Don't worry about any ISA bus models anymore..... 
//look for and IOR return value at the possible IOR addresses
	//	There are not longer any mainboards with ISA slots! ... 2008
	BrdAddr = 0x200;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);	// returns a 0(none), 
												// 1(IOR), 2(MMR), 3(Smart)		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x220;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x280;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x2A0;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x300;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x320;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x380;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x3A0;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}

//look for and MMR/Smart return value at the possible memory map addresses
	BrdAddr = 0xC000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);	//array index, base addr.
			FoundCnt++;
		}	
	}
	BrdAddr = 0xC400;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xC800;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCC00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD400;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD800;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDC00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCD00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCE00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCF00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDD00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDE00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDF00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
--*/
	return FoundCnt;
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	Enables ALL of the time code features that are available on this
//	board.
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	RecordPci(int Cnt, WORD BrdAddr)
{
	WORD		Addr, Offset, OffsetEF;
	BYTE		bId, bType; // bytes from 3E0, 3E1, 3E2, 3EF.
	BYTE		bCom, bRet;
	BOOL		ok;
	
	Addr =  BrdAddr;
	Offset = 0x08;
	OffsetEF = 0x3EF;

	
	// read the smart board type id byte ( 0x50 VLTC, 0x93 VITC, 0x98 LTC)
	//This offset value is NOT IN THE PCI ADDRESS RANGE, BUT THE DLL MAPS
	// this value to a "created" value based upon the data byte at offset
	// 0x08 of the PCI device.
	if (ok = AEC_PCTC_READ_1BYTE (&bType, &OffsetEF, &Addr))	
		AecBoard[Cnt].BrdModel = (WORD)bType;	//3ef

	AecBoard[Cnt].BrdGens = FALSE;
	AecBoard[Cnt].BrdReads = FALSE;
	AecBoard[Cnt].BrdHasVid = FALSE;

	if (ok = AEC_PCTC_READ_1BYTE (&bId, &Offset, &Addr))	
	{

		if ((bId & 0x80) != 0)	//VGen BIT7
		{
			AecBoard[Cnt].BrdGens = TRUE;
			AecBoard[Cnt].BrdHasVid = TRUE;
		}
		if ((bId & 0x40) != 0)	//VRdr BIT6
		{
			AecBoard[Cnt].BrdReads = TRUE;
			AecBoard[Cnt].BrdHasVid = TRUE;	//
		}
		if ((bId & 0x20) != 0)	//LGen BIT5
		{
			AecBoard[Cnt].BrdGens = TRUE;
			AecBoard[Cnt].BrdHasVid = TRUE;
		}
		if ((bId & 0x10) != 0)	//LRdr BIT4
		{
			AecBoard[Cnt].BrdReads = TRUE;
		}

		//Get the board into a know state by sending the "reset"
		// command.
//		bCom = 0x02;	//This command will reset the board read/gen regs
//		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);

		Offset = 0x2F;		// command register offset address
		bId = 0x02;			// RESET Command
		ok = AEC_PCTC_WRITE_1BYTE (&bId, &Offset, &Addr);


		Sleep(400);		//provide enough time for board to get done with "reset"


		bCom = 0x2F;	//This command will enable ALL of the board's
						//	available time code readers/generators
		// The return "bRet" will NOT match, the command, but will be a
		// bit masked value of the features that are available.
		// ie: 0x21(LTC/RDR), 0x22(VITC/RDR), 0x23(VLTC/RDR), 0x2F(VLTC/RG1)
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);

		if (AecBoard[Cnt].BrdGens == TRUE)
		{
			bCom = 0x48;	//This command will start the time code generator
			ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
		}

		Offset = 0x2E;		// interrupt enable flags register offset address
		bId = 0x07;			// enable reader/vid field/generator flags
		ok = AEC_PCTC_WRITE_1BYTE (&bId, &Offset, &Addr);

	}
	//no return for 'void'
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// The ISA models (type 3) take a little special care to simultaneously
// enable the read(s) and generators. This function will only start the
// generator of a smart board IF there is no time code reader.
// However, if the board has a video input, the VIDEO field rate interrupt
// will be enabled
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*++ //This subroutine is not longer needed unless you are developing for our old ISA models
void	RecordSmart(int Cnt, WORD BrdAddr)
{
	WORD		Addr, OffsetE0, OffsetE1, OffsetE2, OffsetEF, Offset;
	BYTE		bId0, bId1, bType; //bId2,  bytes from 3E0, 3E1, 3E2, 3EF.
	BYTE		bCom, bRet;
	BOOL		ok, bGen;
	
	Addr =  BrdAddr;
	OffsetE0 = 0x3E0;
	OffsetE1 = 0x3E1;
	OffsetE2 = 0x3E2;
	OffsetEF = 0x3EF;
	AecBoard[Cnt].BrdGens = FALSE;
	AecBoard[Cnt].BrdReads = FALSE;
	AecBoard[Cnt].BrdHasVid = FALSE;
	bGen = FALSE;
	
	// read the smart board type id byte ( 0x50 VLTC, 0x93 VITC, 0x98 LTC)
	if (ok = AEC_PCTC_READ_1BYTE (&bType, &OffsetEF, &Addr))	
		AecBoard[Cnt].BrdModel = (WORD)bType;
	if ((bType == 0x50) || (bType == 0x93))
		AecBoard[Cnt].BrdHasVid = TRUE;


	// read the board id bytes to see if this board reads tc???
	ok = AEC_PCTC_READ_1BYTE (&bId0, &OffsetE0, &Addr);
	ok = AEC_PCTC_READ_1BYTE (&bId1, &OffsetE1, &Addr);
	//ok = AEC_PCTC_READ_1BYTE (&bId2, &OffsetE2, &Addr);

	//Possible are "RDR", "GEN", "RG1"
	if ((bId0 == 'G' ) || (bId1 == 'G' ))
	{
		AecBoard[Cnt].BrdGens = TRUE;
		AecBoard[Cnt].BrdHasVid = TRUE;		//here for LTC/GEN case
		bGen = TRUE;
	}

	if (ok)		//put the board into IDLE mode for a moment
	{
		bCom = 0x16; // idle command  ltc/vitc/vltc
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
		Sleep(100);
	}

	//--------------------------------
	if (bId0 == 'R' )
	{
		AecBoard[Cnt].BrdGens = FALSE; //THIS may not be true, but we
										//are only going to work with 
										//the reader (& video IF present)					
		AecBoard[Cnt].BrdReads = TRUE;
		// now make sure that the board is in reader mode
		if (bType ==0x50)
			bCom = 0x23; // dual reader mode command vltc board
		else bCom = 0x10; // reader mode command ltc/vitc boards
			
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
	}
	else if (bGen)	//will not get here IF READER is TRUE
	{
		bCom = 0x18; // generator mode command LTC & VITC
		if (bType == 0x50)
			bCom = 0x2C; // dual gen mode command vltc board
			
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
		Sleep(50);
		bCom = 0x48; // Start the generator			
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);

	}

	//Enable software interrupt now by setting the enable flag bits
	bCom = 0x07;			// enable reader/vid field/generator flags
	Offset = 0x3F0;
	ok = AEC_PCTC_WRITE_1BYTE (&bCom, &Offset, &Addr);
	//no return for 'void'
}	--*/


//======================================================================
//This is the function that will set flags based upon what
// interrupts (software) are generated by the PCI time code board
//
//======================================================================
BOOL LookForEvent(int i)
{
	//DWORD		lR4, lW4;
	WORD		Addr, OffsetT, OffsetU;
	BYTE		iCd, bWait; // 
	BOOL		ok, status;


	//Make IF for IOR/MMR boards (type 1/2)

		Addr = AecBoard[i].BrdAddr;
		status = TRUE;
		//If IOR or MMR
/*++	if ((AecBoard[i].BrdCkType == 1) || (AecBoard[i].BrdCkType == 2))
		{
			//ok = AEC_PCTC_READ_UB(&lRUdat, &Addr);	//Get User data
			ok = AEC_PCTC_READ_TB(&lRTdat, &Addr);
			if (lRTdatOld != lRTdat)
			{
				bRnew = TRUE;	
				iReadCnt++;	
				lRTdatOld = lRTdat;
			}
			else
				status = FALSE;
			
		}
		else --*/
		{
			bWait = 0;
			//							(msWait, ret, addr)
			ok = AEC_PCTC_GET_INTCODE(&bWait, &iCd, &Addr);

			// READ output---->
			if (ok)                            // Did succeed?
			{
				switch (iCd)
				{
				case (0x00):
					status = FALSE;
					break;
				case (0x13):	//tc reader interrupt (get time & user (don't worry about Embedded)			
					bRnew = TRUE;
					iReadCnt++;				
					ok = AEC_PCTC_READ_TB(&lRTdat, &Addr);
					//ok = AEC_PCTC_READ_UB(&lRUdat, &Addr);	//Get User data
					break;
				case (0x4C):	//tc generator interrupt
					bGnew = TRUE;
					iGenCnt++;
					OffsetT = 0x0040;	//for PCI
					OffsetU = 0x0044;
					if (AecBoard[i].BrdCkType == 3)
					{
						OffsetT = 0x0050;
						OffsetU = 0x0060;
					}
					ok = AEC_PCTC_READ_4BYTES(&lGTdat, &OffsetT, &Addr);
					//ok = AEC_PCTC_READ_4BYTES(&lGUdat, &OffsetU, &Addr);
					break;

				case (0x44):	//Video field int
					iVidCnt++;
					bVnew = TRUE;
					break;

				default:	//command response, compare, serial...NAK
					iOtherCnt++;
				}
			}    
		}
		return(status);        
}
// ======================================================================
//-----------------------------------------------------------
//Convert a LONG (4byte) value into a character string of TIME (Tm)
//This does NOT mask embedded bits 
// use "dw = (dw & 0x3F7F7F3F);" to mask embedded bits IF needed
//before calling this routine.
//------------------------------------------------------------
int LtoStrTm(ULONG dw, char *chs)	
{
	wsprintf (chs,"%8.8X",dw);
	chs[11] = 0;	//EOL
	chs[10] = chs[7];
	chs[9] = chs[6];
	chs[8] = ':';
	chs[7] = chs[5];
	chs[6] = chs[4];
	chs[5] = ':';
	chs[4] = chs[3];
	chs[3] = chs[2];
	chs[2] = ':';
	return 11;
}

//-----------------------------------------------------------
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	      // END OF CODE	END OF CODE		END OF CODE
